local me={}
local RowHeight=16
local SM = AceLibrary("SharedMedia-1.0")
local Events = AceLibrary("AceEvent-2.0")

--Violation was my reference (I like the basic look of violation just not the backend)
--Make sure to start with row 1 and go upwards when creating though should be safe if you don't just more function calls
function me:CreateRow(num)
	if num<1 or Recount.MainWindow.Rows[num] then
		return
	end

	local row=CreateFrame("Button","Recount_MainWindow_Bar"..num,Recount.MainWindow)
	
	row:SetPoint("TOPLEFT",Recount.MainWindow,"TOPLEFT",2,-14-(RowHeight+2)*num)
	row:SetHeight(RowHeight)
	row:SetWidth(Recount.MainWindow:GetWidth()-4)
	row:SetScript("OnClick", function() 
					if type(this.clickFunc)=="function" and this.clickData then
						this:clickFunc(this.clickData)
						Recount:SelectUpperDetailTable(1)
					end
				end)
	row:EnableMouse(true)
	row:RegisterForClicks("LeftButtonDown")

	--Add code for the button later
	
	row.StatusBar=CreateFrame("StatusBar",nil,row)
	row.StatusBar:SetAllPoints(row)
	row.StatusBar:SetStatusBarTexture(SM:Fetch("statusbar", "BantoBar") )
	row.StatusBar:SetStatusBarColor(.5, .5, .5, 1)
	row.StatusBar:SetMinMaxValues(0,100)
	row.StatusBar:SetValue(100)
	row.StatusBar:Show()

	row.LeftText=row.StatusBar:CreateFontString(nil,"OVERLAY","GameFontHighlightSmall")
	row.LeftText:SetPoint("LEFT", row.StatusBar,"LEFT",2)
	row.LeftText:SetJustifyH("LEFT")
	row.LeftText:SetText("Test")
	row.LeftText:SetTextColor(1,1,1,1)

	row.RightText=row.StatusBar:CreateFontString(nil,"OVERLAY","GameFontHighlightSmall")
	row.RightText:SetPoint("RIGHT", row.StatusBar,"RIGHT",-2)
	row.RightText:SetJustifyH("RIGHT")
	row.RightText:SetText("0")
	row.RightText:SetTextColor(1,1,1,1)

	Recount.MainWindow.Rows[num]=row
	Recount.MainWindow.RowsCreated=num
end

function me:SetBar(num,left,right,value,color,clickData,clickFunc)
	if num<1 or not Recount.MainWindow.Rows[num] then
		return
	end
	
	local Row=Recount.MainWindow.Rows[num]
	Row:Show()
	Row.StatusBar:SetValue(value)
	Row.LeftText:SetText(left)
	Row.RightText:SetText(right)
	Row.clickData=clickData
	Row.clickFunc=clickFunc

	if color then
		Row.StatusBar:SetStatusBarColor(color.r,color.g,color.b,1)
	end
end

function me:ResizeMainWindow()
	--How many bars do we have now?
	local Bars=math.floor((Recount.MainWindow:GetHeight()-32.95)/(RowHeight+2))
	

	if Bars<Recount.MainWindow.CurRows then
		for i=Bars+1,Recount.MainWindow.CurRows do
			Recount.MainWindow.Rows[i]:Hide()
		end
	elseif Bars>Recount.MainWindow.RowsCreated then
		for i=Recount.MainWindow.RowsCreated+1,Bars do
			me:CreateRow(i)
		end
	end

	--Update all the bar widths
	local CurWidth=Recount.MainWindow:GetWidth()-4
	for i=1,Bars do
		Recount.MainWindow.Rows[i]:Show()
		Recount.MainWindow.Rows[i]:SetWidth(CurWidth)
	end

	Recount.MainWindow.CurRows=Bars

	Recount.MainWindow.ScrollBar:SetPoint("TOPLEFT", Recount.MainWindow.Rows[1], "TOPLEFT", -4, 0)
	Recount.MainWindow.ScrollBar:SetPoint("BOTTOMRIGHT", Recount.MainWindow.Rows[Bars], "BOTTOMRIGHT", -4, 0)

	Recount:RefreshMainWindow()
end

function Recount:CreateMainWindow()
	Recount.MainWindow=CreateFrame("Frame","Recount_MainWindow",UIParent)

	local theFrame=Recount.MainWindow

	theFrame:ClearAllPoints()
	theFrame:SetPoint("CENTER",UIParent)
	theFrame:SetHeight(140)
	theFrame:SetWidth(200)

	theFrame:SetBackdrop({
		bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16,
		edgeFile = "Interface\\AddOns\\Recount\\textures\\otravi-semi-full-border", edgeSize = 32,
		insets = {left = 1, right = 1, top = 20, bottom = 1},
	})
	theFrame:SetBackdropBorderColor(1.0,0.0,0.0)
	theFrame:SetBackdropColor(24/255, 24/255, 24/255)

	theFrame:EnableMouse(true)
	theFrame:SetMovable(true)
	theFrame:SetResizable(true)

	theFrame:SetMinResize(140,63)
	theFrame:SetMaxResize(400,520)	

	theFrame:SetScript("OnMouseDown", function() 
						if ( ( ( not this.isLocked ) or ( this.isLocked == 0 ) ) and ( arg1 == "LeftButton" ) ) then
						  this:StartMoving();
						  this.isMoving = true;
						 end
						end)
	theFrame:SetScript("OnMouseUp", function() 
						if ( this.isMoving ) then
						  this:StopMovingOrSizing();
						  this.isMoving = false;
						 end
						end)
	theFrame:SetScript("OnShow", function()
						Events:ScheduleRepeatingEvent(Recount.RefreshMainWindow,1)
						end)
					
	theFrame:SetScript("OnHide", function()  Events:CancelAllScheduledEvents()
						if ( this.isMoving ) then
						  this:StopMovingOrSizing();
						  this.isMoving = false;
						 end
						end)
	theFrame:SetScript("OnSizeChanged", function()
						if ( this.isResizing ) then
							me:ResizeMainWindow()
						end
					end)

	theFrame.Title=theFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
	theFrame.Title:SetPoint("TOPLEFT",theFrame,"TOPLEFT",6,-15)
	theFrame.Title:SetTextColor(1.0,1.0,1.0)


	theFrame.ScrollBar=CreateFrame("SCROLLFRAME","Recount_MainWindow_ScrollBar",theFrame,"FauxScrollFrameTemplate")
	theFrame.ScrollBar:SetScript("OnVerticalScroll", function() FauxScrollFrame_OnVerticalScroll(20, Recount.RefreshMainWindow) end)

	


	theFrame.DragBottomRight = CreateFrame("Frame", nil, theFrame)
	theFrame.DragBottomRight:Show()
	theFrame.DragBottomRight:SetFrameLevel( theFrame:GetFrameLevel() + 10)
	theFrame.DragBottomRight:SetWidth(16)
	theFrame.DragBottomRight:SetHeight(16)
	theFrame.DragBottomRight:SetPoint("BOTTOMRIGHT", theFrame, "BOTTOMRIGHT", 0, 0)
	theFrame.DragBottomRight:EnableMouse(true)
	theFrame.DragBottomRight:SetScript("OnMouseDown", function() this:GetParent().isResizing = true; this:GetParent():StartSizing("BOTTOMRIGHT") end )
	theFrame.DragBottomRight:SetScript("OnMouseUp", function() this:GetParent():StopMovingOrSizing(); this:GetParent().isResizing = false; end )


	theFrame.DragBottomLeft = CreateFrame("Frame", nil, theFrame)
	theFrame.DragBottomLeft:Show()
	theFrame.DragBottomLeft:SetFrameLevel( theFrame:GetFrameLevel() + 10)
	theFrame.DragBottomLeft:SetWidth(16)
	theFrame.DragBottomLeft:SetHeight(16)
	theFrame.DragBottomLeft:SetPoint("BOTTOMLEFT", theFrame, "BOTTOMLEFT", 0, 0)
	theFrame.DragBottomLeft:EnableMouse(true)
	theFrame.DragBottomLeft:SetScript("OnMouseDown", function() this:GetParent().isResizing = true; this:GetParent():StartSizing("BOTTOMLEFT") end )
	theFrame.DragBottomLeft:SetScript("OnMouseUp", function() this:GetParent():StopMovingOrSizing(); this:GetParent().isResizing = false; end )

	theFrame.CloseButton=CreateFrame("Button",nil,theFrame)
	theFrame.CloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
	theFrame.CloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
	theFrame.CloseButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
	theFrame.CloseButton:SetWidth(20)
	theFrame.CloseButton:SetHeight(20)
	theFrame.CloseButton:SetPoint("TOPRIGHT",theFrame,"TOPRIGHT",-4,-12)
	theFrame.CloseButton:SetScript("OnClick",function() this:GetParent():Hide() end)


	theFrame.LeftButton=CreateFrame("Button",nil,theFrame)
	theFrame.LeftButton:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up.blp")
	theFrame.LeftButton:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down.blp")
	theFrame.LeftButton:SetWidth(16)
	theFrame.LeftButton:SetHeight(18)
	theFrame.LeftButton:SetPoint("TOPRIGHT",theFrame,"TOPRIGHT",-40,-12)
	theFrame.LeftButton:SetScript("OnClick",function() Recount:MainWindowPrevMode() end)

	theFrame.RightButton=CreateFrame("Button",nil,theFrame)
	theFrame.RightButton:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up.blp")
	theFrame.RightButton:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down.blp")	
	theFrame.RightButton:SetWidth(16)
	theFrame.RightButton:SetHeight(18)
	theFrame.RightButton:SetPoint("LEFT",theFrame.LeftButton,"RIGHT",1,0)
	theFrame.RightButton:SetScript("OnClick",function() Recount:MainWindowNextMode() end)

	Recount.MainWindow.Rows={}
	Recount.MainWindow.CurRows=0
	Recount.MainWindow.RowsCreated=0

	me:ResizeMainWindow()
	Events:ScheduleRepeatingEvent(Recount.RefreshMainWindow,1)
end


--Actual Data Functions
function sortFunc(a, b)
	if a[2]>b[2] then
		return true
	end
	return false
end

function Recount:LoadMainWindowData(DataTable)
	Recount.MainWindowData=DataTable
	Recount:SetMainWindowMode(1)
end

function Recount:SetMainWindowMode(mode)
	Recount.MainWindowMode=mode
	Recount.DetailMode=1
	local data=Recount.MainWindowData[mode]
	Recount.MainWindow.Title:SetText(data[1])
	Recount.MainWindow.GetData=data[2]
	Recount:RefreshMainWindow()
end

function Recount:MainWindowNextMode()
	local mode=Recount.MainWindowMode+1
	if mode>table.maxn(Recount.MainWindowData) then
		mode=1
	end
	Recount:SetMainWindowMode(mode)
end

function Recount:MainWindowPrevMode()
	local mode=Recount.MainWindowMode-1
	if mode==0 then
		mode=table.maxn(Recount.MainWindowData)
	end
	Recount:SetMainWindowMode(mode)
end

function Recount:DetailWindowNextMode()
	local _, Data=Recount.MainWindow:GetData(Recount.db.char.combatants[Recount.MainWindow.Selected])
	
	local mode=Recount.DetailMode+1
	if mode>table.maxn(Data) then
		mode=1
	end
	Recount.DetailMode=mode

	me:MainWindowSelectPlayer(Recount.MainWindow.Selected)
end

function Recount:DetailWindowPrevMode()
	local _, Data=Recount.MainWindow:GetData(Recount.db.char.combatants[Recount.MainWindow.Selected])
	local mode=Recount.DetailMode-1
	if mode==0 then
		mode=table.maxn(Data)
	end
	Recount.DetailMode=mode
	
	me:MainWindowSelectPlayer(Recount.MainWindow.Selected)
end

function me:MainWindowSelectPlayer(name)
	if IsShiftKeyDown() then
		Recount:SetGraphData(name,Recount.db.char.combatants[name].TimeData,Recount.db.char.CombatTimes)
		return
	end

	local _, Data=Recount.MainWindow:GetData(Recount.db.char.combatants[name])
	local mode=Recount.DetailMode
	Recount:SetupDetailTitles(name,Data[mode][2],Data[mode][3])
	Recount:FillUpperDetailTable(Data[mode][1])
	Recount.MainWindow.Selected=name
end

function Recount:RefreshMainWindow()
	if not Recount.MainWindow.GetData or not Recount.MainWindow:IsShown() then
		return
	end
	local data=Recount.db.char.combatants
	local i, maxValue
	local dispTable={}
	local Total=0

	
	if type(data)=="table" then
		for k,v in pairs(data) do
			local Value,_=Recount.MainWindow:GetData(v)
			if Value>0 then
				Total=Total+Value
				table.insert(dispTable,{k,Value,RAID_CLASS_COLORS[v.enClass]})
			end
		end
	end
	
	if table.maxn(dispTable)>0 then
		table.sort(dispTable,sortFunc)
		MaxValue=dispTable[1][2]
	end

	local RowWidth=Recount.MainWindow:GetWidth()-4
	if table.getn(dispTable)>Recount.MainWindow.CurRows then
		RowWidth=Recount.MainWindow:GetWidth()-24
	end

	FauxScrollFrame_Update(Recount.MainWindow.ScrollBar, table.getn(dispTable), Recount.MainWindow.CurRows, 14)
	local offset = FauxScrollFrame_GetOffset(Recount.MainWindow.ScrollBar)

	for i=1,Recount.MainWindow.CurRows do
		local v=dispTable[i+offset]
		
		if v then
			local percent=100*v[2]/Total
			me:SetBar(i,i+offset..". "..v[1],v[2].." ("..math.floor(percent).."%)",100*v[2]/MaxValue,v[3],v[1],me.MainWindowSelectPlayer)
		else
			Recount.MainWindow.Rows[i]:Hide()
		end

		Recount.MainWindow.Rows[i]:SetWidth(RowWidth)
	end
	if Recount.MainWindow.Selected and Recount.DetailWindow:IsShown() then
		me:MainWindowSelectPlayer(Recount.MainWindow.Selected)
	end
end