--Data for Recount is tracked within this file

function Recount_ParseDamageEvent(event, info)
	local HitType 
	local source, victim, ability

	ability=info.skill

	if ability==ParserLib_MELEE then
		ability="Melee"
	elseif ability==ParserLib_DAMAGESHIELD then
		ability="Damage Shields"
	end


	source=info.source
	if source==ParserLib_SELF then
		source=UnitName("player")
	elseif source==ParserLib_NONE then
		source="No One"
	end

	victim=info.victim
	if victim==ParserLib_SELF then
		victim=UnitName("player")
	elseif victim==ParserLib_NONE then
		victim="No One"
	end

	if not info.element then
		info.element="Physical"
	end

	--Long switch of figuring out the type now
	HitType="Hit"
	if info.isCrit then
		HitType="Crit"
	end
	if info.isDOT then
		HitType="Tick"
	end
	if info.isSplit then
		HitType="Split"
	end
	if info.isCrushing then
		HitType="Crushing"
	end
	if info.isGlancing then
		HitType="Glancing"
	end
	if info.amountBlock then
		HitType="Block"
	end

	Recount:AddDamageData(source, victim, ability, info.element or "Physical", HitType, info.amount, info.amountResist)
end

function Recount_ParseMissEvent(event, info)
	local source,victim,ability

	ability=info.skill

	if ability==ParserLib_MELEE then
		ability="Melee"
	end

	source=info.source
	if source==ParserLib_SELF then
		source=UnitName("player")
	elseif source==ParserLib_NONE then
		source="No One"
	end

	victim=info.victim
	if victim==ParserLib_SELF then
		victim=UnitName("player")
	elseif victim==ParserLib_NONE then
		victim="No One"
	end

	Recount:AddDamageData(source, victim, ability, nil, string.upper(string.sub(info.missType,1,1))..string.sub(info.missType,2))
end

function Recount_ParseHealEvent(event, info)
	local source,victim, type

	source=info.source
	if source==ParserLib_SELF then
		source=UnitName("player")
	elseif source==ParserLib_NONE then
		source="No One"
	end

	victim=info.victim
	if victim==ParserLib_SELF then
		victim=UnitName("player")
	elseif victim==ParserLib_NONE then
		victim="No One"
	end

	local healtype="Hit"
	if info.isCrit then
		healtype="Crit"
	end

	if info.isDOT then
		healtype="Tick"
	end

	Recount:AddHealData(source, victim, info.skill, healtype, info.amount)
end

--Functions for adding data 
function Recount:AddAmount(who,datatype,amount)
	--We add the data to both overall & current fight data
	who.OverallData[datatype]=who.OverallData[datatype]+amount
	who.CurrentFightData[datatype]=who.CurrentFightData[datatype]+amount

	--Now add the time data
	if who.TimeWindows[datatype] then
		who.TimeWindows[datatype][Recount.TimeStep]=who.TimeWindows[datatype][Recount.TimeStep]+amount
	end
end

--Meant for like elemental data and this type isn't expected to be initialized 
function Recount:AddAmount2(who,datatype,secondary,amount)
	--We add the data to both overall & current fight data
	who.OverallData[datatype][secondary]=(who.OverallData[datatype][secondary] or 0)+amount
	who.CurrentFightData[datatype][secondary]=(who.CurrentFightData[datatype][secondary] or 0)+amount
end

--Two Different Types of table functions
--First type tracks min/max & count while the other only counts the total sum in the count column
function Recount:AddTableDataStats(who,datatype,secondary,detailtype,amount)
	if type(who.OverallData[datatype][secondary])~="table" then
		who.OverallData[datatype][secondary]={}
		who.OverallData[datatype][secondary].count=0
		who.OverallData[datatype][secondary].amount=0
		who.OverallData[datatype][secondary].Details={}
	end

	local CurTable=who.OverallData[datatype][secondary]

	CurTable.count=CurTable.count+1
	CurTable.amount=CurTable.amount+amount

	if type(CurTable.Details[detailtype])~="table" then
		CurTable.Details[detailtype]={}
		CurTable.Details[detailtype].count=0
		CurTable.Details[detailtype].amount=0
	end
	local Details=CurTable.Details[detailtype]

	Details.count=Details.count+1
	Details.amount=Details.amount+amount

	if Details.max then
		if amount>Details.max then
			Details.max=amount
		elseif amount<Details.min then
			Details.min=amount
		end
	else--If no max has been set time to initialize
		Details.max=amount
		Details.min=amount
	end


	--Now for the current fight data
	if type(who.CurrentFightData[datatype][secondary])~="table" then
		who.CurrentFightData[datatype][secondary]={}
		who.CurrentFightData[datatype][secondary].count=0
		who.CurrentFightData[datatype][secondary].amount=0
		who.CurrentFightData[datatype][secondary].Details={}
	end

	CurTable=who.CurrentFightData[datatype][secondary]

	CurTable.count=CurTable.count+1
	CurTable.amount=CurTable.amount+amount

	if type(CurTable.Details[detailtype])~="table" then
		CurTable.Details[detailtype]={}
		CurTable.Details[detailtype].count=0
		CurTable.Details[detailtype].amount=0
	end
	Details=CurTable.Details[detailtype]

	Details.count=Details.count+1
	Details.amount=Details.amount+amount

	if Details.max then
		if amount>Details.max then
			Details.max=amount
		elseif amount<Details.min then
			Details.min=amount
		end
	else--If no max has been set time to initialize
		Details.max=amount
		Details.min=amount
	end
end


function Recount:AddTableDataSum(who,datatype,secondary,detailtype,amount)
	if type(who.OverallData[datatype][secondary])~="table" then
		who.OverallData[datatype][secondary]={}
		who.OverallData[datatype][secondary].amount=0
		who.OverallData[datatype][secondary].Details={}
	end

	local CurTable=who.OverallData[datatype][secondary]

	CurTable.amount=CurTable.amount+amount

	if type(CurTable.Details[detailtype])~="table" then
		CurTable.Details[detailtype]={}
		CurTable.Details[detailtype].count=0
	end
	local Details=CurTable.Details[detailtype]
	Details.count=Details.count+amount


	--Now for the current fight data
	if type(who.CurrentFightData[datatype][secondary])~="table" then
		who.CurrentFightData[datatype][secondary]={}
		who.CurrentFightData[datatype][secondary].amount=0
		who.CurrentFightData[datatype][secondary].Details={}
	end

	CurTable=who.CurrentFightData[datatype][secondary]

	CurTable.amount=CurTable.amount+amount

	if type(CurTable.Details[detailtype])~="table" then
		CurTable.Details[detailtype]={}
		CurTable.Details[detailtype].count=0
	end
	Details=CurTable.Details[detailtype]

	Details.count=Details.count+amount
end

--
function Recount:AddDamageData(source, victim, ability, element, hittype, damage, resist)
	--Recount:Print("Damage event added for "..source.." attacking "..victim.." with "..ability.." with result of "..hittype)
	--See if both the source & victim are in the tables
	if type(Recount.db.char.combatants[source])~="table" then
		Recount:AddCombatant(source)
	end
	if type(Recount.db.char.combatants[victim])~="table" then
		Recount:AddCombatant(victim)
	end

	local sourceData=Recount.db.char.combatants[source]
	local victimData=Recount.db.char.combatants[victim]

	--Is this friendly fire?
	local FriendlyFire=sourceData.isFriend==victimData.isFriend

	if damage then
		--Victim always cares
		Recount:AddAmount(victimData,"DamageTaken",damage)
		Recount:AddAmount2(victimData,"ElementTaken",element,damage)
		Recount:AddTableDataSum(victimData,"WhoDamaged",source,ability,damage)
		if resist then
			Recount:AddAmount2(victimData,"ElementTakenResist",element,damage)
		end
		
		--Alright now if there was a friendly damage done or not decides where this data goes for the source
		if not FriendlyFire then
			Recount:AddAmount(sourceData,"Damage",damage)	
			Recount:AddTableDataStats(sourceData,"Attacks",ability,hittype,damage)
			Recount:AddAmount2(sourceData,"ElementDone",element,damage)
			if resist then
				Recount:AddAmount2(sourceData,"ElementDoneResist",element,resist)
			end

			--Set the back link to the victims table data on who was hurting them
			sourceData.OverallData.DamagedWho[victim]=victimData.OverallData.WhoDamaged[source]
			sourceData.CurrentFightData.DamagedWho[victim]=victimData.CurrentFightData.WhoDamaged[source]
		else
			Recount:AddAmount(sourceData,"FDamage",damage)
			Recount:AddTableDataStats(sourceData,"FAttacks",ability,hittype,damage)
			sourceData.OverallData.FDamagedWho[victim]=victimData.OverallData.WhoDamaged[source]
			sourceData.CurrentFightData.FDamagedWho[victim]=victimData.CurrentFightData.WhoDamaged[source]
		end
	end
end

function Recount:AddHealData(source, victim, ability, healtype, amount)
	--First lets figure if there was overhealing
	local Overheal=0

	local VictimUnit=Recount:FindUnit(victim)
	if VictimUnit then
		local HealthMissing = UnitHealthMax(VictimUnit)-UnitHealth(VictimUnit)
		if HealthMissing<amount then
			Overheal=amount-HealthMissing
			amount=HealthMissing --Adjust healing considered to the correct number
		end
	end

	--Get the tables
	if type(Recount.db.char.combatants[source])~="table" then
		Recount:AddCombatant(source)
	end
	if type(Recount.db.char.combatants[victim])~="table" then
		Recount:AddCombatant(victim)
	end

	local sourceData=Recount.db.char.combatants[source]
	local victimData=Recount.db.char.combatants[victim]

	--No reason to add information if everything was overhealing
	if amount>0 then
		Recount:AddAmount(sourceData,"Healing",amount)
		Recount:AddAmount(victimData,"HealingTaken",amount)

		Recount:AddTableDataStats(sourceData,"Heals",ability,healtype,amount)

		Recount:AddTableDataSum(sourceData,"HealedWho",victim,ability,amount)

		victimData.OverallData.WhoHealed[source]=sourceData.OverallData.HealedWho[victim]
		victimData.CurrentFightData.WhoHealed[source]=sourceData.CurrentFightData.HealedWho[victim]
	end

	--Now if there was overhealing lets add that data in
	if Overheal>0 then
		Recount:AddAmount(sourceData,"Overhealing",Overheal)
		Recount:AddTableDataStats(sourceData,"OverHeals",ability,healtype,Overheal)
	end
end